// Read all filenames from directory and it's subdirectories

'use strict';

var fs      = require('fs')
  , aritize = require('es5-ext/lib/Function/aritize').call
  , curry   = require('es5-ext/lib/Function/curry').call
  , invoke  = require('es5-ext/lib/Function/invoke')
  , flatten = require('es5-ext/lib/List/flatten').call
  , a2p     = require('deferred/lib/async-to-promise').call
  , all     = require('deferred/lib/join/all')
  , concat  = aritize(String.prototype.concat, 1)

  , trim    = require('../path/trim');

module.exports = function readdir (path, callback) {
	path = trim(path);
	a2p(fs.readdir, path)
	(function (files) {
		return all(files.map(function (file) {
			var npath = path + '/' + file;
			return a2p(fs.stat, npath)
			(function (stats) {
				if (stats.isFile()) {
					return file;
				} else if (stats.isDirectory()) {
					return a2p(readdir, npath)
					(invoke('map', concat, file + '/'));
				} else {
					return null;
				}
			});
		}))
		(invoke('filter', Boolean))
		(flatten)
		(curry(callback, null));
	}).end(callback);
};
